"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const jsx_runtime_1 = require("react/jsx-runtime");
const isArray_1 = tslib_1.__importDefault(require("lodash/isArray"));
const without_1 = tslib_1.__importDefault(require("lodash/without"));
const react_1 = tslib_1.__importDefault(require("react"));
const Contexts_1 = require("../Contexts");
const Field_1 = tslib_1.__importDefault(require("../Field"));
const Object_1 = tslib_1.__importDefault(require("../Object"));
const defaultProps = {
    addLabel: 'Add',
    removeLabel: 'Remove',
    errorMessages: {},
    autoAddItem: false,
    showAddButton: true,
    showRemoveButton: true,
    renderProps: false,
};
class ArrayComponent extends react_1.default.Component {
    addItem(itemValue = {}) {
        var newArray = this.props.value;
        if ((0, isArray_1.default)(newArray)) {
            newArray.push(itemValue);
        }
        else {
            newArray = [itemValue];
        }
        this.props.onChange(newArray);
    }
    getObjectField() {
        return Object_1.default;
    }
    removeItem(index) {
        const value = this.props.value || [];
        var newArray = (0, without_1.default)(value, value[index]);
        this.props.onChange(newArray);
    }
    getChildrenComponents(item, index) {
        if (this.props.renderItem)
            return this.props.renderItem(item, index);
        if (this.props.children)
            return this.props.children;
    }
    renderChildren() {
        const value = this.props.value || [];
        if (this.props.autoAddItem && !this.props.disabled && value.length === 0) {
            value.push({});
        }
        return value.map((item, index) => {
            const children = this.getChildrenComponents(item, index);
            return this.renderChildrenItem({ index, children });
        });
    }
    renderChildrenItem({ index, children }) {
        const button = this.props.showRemoveButton
            ? this.renderButton(() => this.removeItem(index), this.props.removeLabel, 'srf_removeButton')
            : null;
        return ((0, jsx_runtime_1.jsxs)("div", { style: { marginTop: 20, marginBottom: 20, padding: 20 }, children: [this.renderChildrenItemWithContext({ index, children }), button] }, `${this.props.fieldName}.${index}`));
    }
    renderChildrenItemWithContext({ index, children }) {
        return ((0, jsx_runtime_1.jsx)(Contexts_1.ParentFieldNameContext.Provider, { value: this.props.fieldName, children: (0, jsx_runtime_1.jsx)(Field_1.default, { fieldName: String(index), type: this.getObjectField(), children: this.props.renderProps ? children(index) : children }) }, index));
    }
    renderButton(onClick, label, className) {
        return ((0, jsx_runtime_1.jsx)("div", { style: { marginTop: 10 }, children: (0, jsx_runtime_1.jsx)("button", { type: "button", className: className, onClick: onClick, children: label }) }));
    }
    renderErrorMessage() {
        if (!this.props.errorMessage)
            return;
        return ((0, jsx_runtime_1.jsx)("div", { style: { color: 'red' }, className: "srf_errorMessage", children: this.props.errorMessage }));
    }
    render() {
        return ((0, jsx_runtime_1.jsxs)("div", { className: "srf-array-container", style: { marginTop: 20 }, children: [(0, jsx_runtime_1.jsx)("div", { children: (0, jsx_runtime_1.jsx)("b", { children: this.props.label }) }), this.renderErrorMessage(), this.renderChildren(), this.props.showAddButton
                    ? this.renderButton(() => this.addItem(), this.props.addLabel, 'srf_addButton')
                    : null] }));
    }
}
ArrayComponent.defaultProps = defaultProps;
exports.default = ArrayComponent;
//# sourceMappingURL=index.js.map