"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const jsx_runtime_1 = require("react/jsx-runtime");
const cloneDeep_1 = tslib_1.__importDefault(require("lodash/cloneDeep"));
const isEqual_1 = tslib_1.__importDefault(require("lodash/isEqual"));
const isNil_1 = tslib_1.__importDefault(require("lodash/isNil"));
const omit_1 = tslib_1.__importDefault(require("lodash/omit"));
const react_1 = require("react");
const use_deep_compare_effect_1 = tslib_1.__importDefault(require("use-deep-compare-effect"));
const Contexts_1 = require("../Contexts");
const isReactNative_1 = tslib_1.__importDefault(require("../utility/isReactNative"));
const getNewValue_1 = tslib_1.__importDefault(require("./getNewValue"));
function Form(props, ref) {
    const initialPropsState = (0, react_1.useMemo)(() => (0, cloneDeep_1.default)(props.state || {}), [props.state]);
    const [state, setState] = (0, react_1.useState)(initialPropsState);
    const resetState = (0, react_1.useCallback)(() => {
        if ((0, isEqual_1.default)(state, initialPropsState))
            return;
        setState(initialPropsState);
    }, [initialPropsState, state]);
    (0, use_deep_compare_effect_1.default)(() => {
        if (!(0, isNil_1.default)(props.state)) {
            resetState();
        }
    }, [props.state || {}]);
    const onChange = (0, react_1.useCallback)((fieldName, fieldValue) => {
        setState(oldValue => (0, getNewValue_1.default)(oldValue, fieldName, fieldValue));
    }, []);
    (0, react_1.useEffect)(() => {
        if (!props.onChange)
            return;
        if ((0, isEqual_1.default)(initialPropsState, state))
            return;
        props.onChange(state);
    }, [state]);
    const submit = (0, react_1.useCallback)(() => {
        props.onSubmit?.(state);
    }, [state, props.onSubmit]);
    const onFormSubmit = (event) => {
        event.preventDefault();
        return submit();
    };
    (0, react_1.useImperativeHandle)(ref, () => ({
        submit,
        getValue: () => state,
        reset: resetState,
    }), [resetState, state, submit]);
    const renderChild = () => {
        const domProps = (0, omit_1.default)(props, 'children', 'state', 'onChange', 'errorMessages', 'useFormTag', 'onSubmit');
        if ((0, isReactNative_1.default)()) {
            return props.children;
        }
        if (props.useFormTag !== false) {
            return ((0, jsx_runtime_1.jsx)("form", { ...domProps, onSubmit: onFormSubmit, children: props.children }));
        }
        return props.children;
    };
    return ((0, jsx_runtime_1.jsx)(Contexts_1.ParentFieldNameContext.Provider, { value: null, children: (0, jsx_runtime_1.jsx)(Contexts_1.ErrorMessagesContext.Provider, { value: props.errorMessages, children: (0, jsx_runtime_1.jsx)(Contexts_1.OnChangeContext.Provider, { value: onChange, children: (0, jsx_runtime_1.jsx)(Contexts_1.ValueContext.Provider, { value: state, children: renderChild() }) }) }) }));
}
exports.default = (0, react_1.forwardRef)(Form);
//# sourceMappingURL=index.js.map