"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("@testing-library/react");
const react_2 = tslib_1.__importStar(require("react"));
const Field_1 = tslib_1.__importDefault(require("../Field"));
const Form_1 = tslib_1.__importDefault(require("../Form"));
const index_1 = tslib_1.__importDefault(require("./index"));
require("@testing-library/jest-dom");
jest.useFakeTimers();
class DummyInput extends react_2.default.Component {
    render() {
        return ((0, jsx_runtime_1.jsx)("input", { value: this.props.value || '', onChange: event => {
                this.props.onChange(event.target.value);
            } }));
    }
}
it('should render correctly', () => {
    const { container } = (0, react_1.render)((0, jsx_runtime_1.jsx)(Form_1.default, { children: (0, jsx_runtime_1.jsx)(Field_1.default, { fieldName: "object", type: index_1.default, children: (0, jsx_runtime_1.jsx)("div", { className: "children" }) }) }));
    expect(container.querySelector('.children')).toBeInTheDocument();
});
it('should show an error if it has one', () => {
    const { container } = (0, react_1.render)((0, jsx_runtime_1.jsx)(Form_1.default, { errorMessages: { item: 'I AM AN ERROR' }, children: (0, jsx_runtime_1.jsx)(Field_1.default, { fieldName: "item", type: index_1.default, children: (0, jsx_runtime_1.jsx)("div", { className: "children" }) }) }));
    expect(container.querySelector('.srf_errorMessage')).toHaveTextContent('I AM AN ERROR');
});
it('should pass the value to the child field', () => {
    const { container } = (0, react_1.render)((0, jsx_runtime_1.jsx)(Form_1.default, { state: { object: { field: 'hello' } }, children: (0, jsx_runtime_1.jsx)(Field_1.default, { fieldName: "object", type: index_1.default, children: (0, jsx_runtime_1.jsx)(Field_1.default, { fieldName: "field", type: DummyInput }) }) }));
    expect(container.querySelector('input')).toHaveValue('hello');
});
test('onChange should make changes correctly', () => {
    let state = { person: { name: 'Nicolás' } };
    const { container } = (0, react_1.render)((0, jsx_runtime_1.jsx)(Form_1.default, { state: state, onChange: (changes) => {
            state = changes;
        }, children: (0, jsx_runtime_1.jsx)(Field_1.default, { fieldName: "person", type: index_1.default, children: (0, jsx_runtime_1.jsx)(Field_1.default, { fieldName: "name", type: DummyInput }) }) }));
    (0, react_2.act)(() => {
        react_1.fireEvent.change(container.querySelector('input'), { target: { value: 'Joaquín' } });
        jest.advanceTimersByTime(0);
    });
    expect(state).toEqual({ person: { name: 'Joaquín' } });
});
//# sourceMappingURL=index.test.js.map